<!DOCTYPE html>
<html class="" lang="en">
<head prefix="og: http://ogp.me/ns#">
<meta charset="utf-8">
<link href="https://assets.gitlab-static.net" rel="dns-prefetch">
<link crossorigin="" href="https://assets.gitlab-static.net" rel="preconnnect">
<meta content="IE=edge" http-equiv="X-UA-Compatible">
<meta content="object" property="og:type">
<meta content="GitLab" property="og:site_name">
<meta content="Files · master · GitLab.org / gitlab-workhorse" property="og:title">
<meta content="Handles slow HTTP requests for GitLab" property="og:description">
<meta content="/uploads/-/system/project/avatar/554859/workhorse_logo.png" property="og:image">
<meta content="64" property="og:image:width">
<meta content="64" property="og:image:height">
<meta content="https://gitlab.com/gitlab-org/gitlab-workhorse/-/tree/master" property="og:url">
<meta content="summary" property="twitter:card">
<meta content="Files · master · GitLab.org / gitlab-workhorse" property="twitter:title">
<meta content="Handles slow HTTP requests for GitLab" property="twitter:description">
<meta content="/uploads/-/system/project/avatar/554859/workhorse_logo.png" property="twitter:image">

<title>Files · master · GitLab.org / gitlab-workhorse · GitLab</title>
<meta content="Handles slow HTTP requests for GitLab" name="description">
<link rel="shortcut icon" type="image/png" href="https://gitlab.com/assets/favicon-yellow-bef6823e78fa007bd8a5fd5f432d3e1487e0bd6631717726b5029997f32cecfc.png" id="favicon" data-original-href="https://gitlab.com/assets/favicon-yellow-bef6823e78fa007bd8a5fd5f432d3e1487e0bd6631717726b5029997f32cecfc.png" />
<link rel="stylesheet" media="all" href="https://assets.gitlab-static.net/assets/application-f6593e4dee4565ff82f3af323cd221d52ccdef896072f9bb4f5ade1ecfd7b5e2.css" />
<link rel="stylesheet" media="print" href="https://assets.gitlab-static.net/assets/print-74c3df10dad473d66660c828e3aa54ca3bfeac6d8bb708643331403fe7211e60.css" />


<link rel="stylesheet" media="all" href="https://assets.gitlab-static.net/assets/highlight/themes/white-a20fa0d18cb98944b079c02ad5a6f46cb362f986ffd703fda24b3e8e2a4a8874.css" />
<script nonce="BddZj//wH2WzCiOHGWzR7Q==">
//<![CDATA[
window.gon={};gon.features={"vueFileListLfsBadge":false};
//]]>
</script>

<script src="https://assets.gitlab-static.net/assets/webpack/runtime.d44254e3.bundle.js" defer="defer"></script>
<script src="https://assets.gitlab-static.net/assets/webpack/main.30fb3353.chunk.js" defer="defer"></script>
<script src="https://assets.gitlab-static.net/assets/webpack/sentry.9ad39fdf.chunk.js" defer="defer"></script>
<script src="https://assets.gitlab-static.net/assets/webpack/commons~pages.admin.clusters~pages.admin.clusters.destroy~pages.admin.clusters.edit~pages.admin.clus~a979c9a8.5fff157e.chunk.js" defer="defer"></script>
<script src="https://assets.gitlab-static.net/assets/webpack/commons~pages.admin.application_settings~pages.admin.application_settings.ci_cd~pages.admin.applicat~b41ec949.10a8409c.chunk.js" defer="defer"></script>
<script src="https://assets.gitlab-static.net/assets/webpack/pages.projects.tree.show.ce331dac.chunk.js" defer="defer"></script>

<meta name="csrf-param" content="authenticity_token" />
<meta name="csrf-token" content="FJOn6IuL2fZ7TNt2SSdMy6Fe/05Wu61RUkQpn/FCJGX39T5rHv8tEkXf+lGp3Fchmsbq83D9SMMpQpfR/QITVQ==" />
<meta name="csp-nonce" content="BddZj//wH2WzCiOHGWzR7Q==" />
<meta content="width=device-width, initial-scale=1, maximum-scale=1" name="viewport">
<meta content="#474D57" name="theme-color">
<link rel="apple-touch-icon" type="image/x-icon" href="https://assets.gitlab-static.net/assets/touch-icon-iphone-5a9cee0e8a51212e70b90c87c12f382c428870c0ff67d1eb034d884b78d2dae7.png" />
<link rel="apple-touch-icon" type="image/x-icon" href="https://assets.gitlab-static.net/assets/touch-icon-ipad-a6eec6aeb9da138e507593b464fdac213047e49d3093fc30e90d9a995df83ba3.png" sizes="76x76" />
<link rel="apple-touch-icon" type="image/x-icon" href="https://assets.gitlab-static.net/assets/touch-icon-iphone-retina-72e2aadf86513a56e050e7f0f2355deaa19cc17ed97bbe5147847f2748e5a3e3.png" sizes="120x120" />
<link rel="apple-touch-icon" type="image/x-icon" href="https://assets.gitlab-static.net/assets/touch-icon-ipad-retina-8ebe416f5313483d9c1bc772b5bbe03ecad52a54eba443e5215a22caed2a16a2.png" sizes="152x152" />
<link color="rgb(226, 67, 41)" href="https://assets.gitlab-static.net/assets/logo-d36b5212042cebc89b96df4bf6ac24e43db316143e89926c0db839ff694d2de4.svg" rel="mask-icon">
<meta content="https://assets.gitlab-static.net/assets/msapplication-tile-1196ec67452f618d39cdd85e2e3a542f76574c071051ae7effbfde01710eb17d.png" name="msapplication-TileImage">
<meta content="#30353E" name="msapplication-TileColor">
<link rel="alternate" type="application/atom+xml" title="gitlab-workhorse:master commits" href="https://gitlab.com/gitlab-org/gitlab-workhorse/-/commits/master?format=atom" />



<script nonce="BddZj//wH2WzCiOHGWzR7Q==">
//<![CDATA[
;(function(p,l,o,w,i,n,g){if(!p[i]){p.GlobalSnowplowNamespace=p.GlobalSnowplowNamespace||[];
p.GlobalSnowplowNamespace.push(i);p[i]=function(){(p[i].q=p[i].q||[]).push(arguments)
};p[i].q=p[i].q||[];n=l.createElement(o);g=l.getElementsByTagName(o)[0];n.async=1;
n.src=w;g.parentNode.insertBefore(n,g)}}(window,document,"script","https://assets.gitlab-static.net/assets/snowplow/sp-e10fd598642f1a4dd3e9e0e026f6a1ffa3c31b8a40efd92db3f92d32873baed6.js","snowplow"));

window.snowplowOptions = {"namespace":"gl","hostname":"snowplow.trx.gitlab.net","cookieDomain":".gitlab.com","appId":"gitlab","formTracking":true,"linkClickTracking":true,"igluRegistryUrl":null}


//]]>
</script>
</head>

<body class="ui-indigo tab-width-8  gl-browser-safari gl-platform-ios" data-find-file="/gitlab-org/gitlab-workhorse/-/find_file/master" data-group="" data-namespace-id="9970" data-page="projects:tree:show" data-page-type-id="master" data-project="gitlab-workhorse" data-project-id="554859">

<script nonce="BddZj//wH2WzCiOHGWzR7Q==">
//<![CDATA[
gl = window.gl || {};
gl.client = {"isSafari":true,"isIos":true};


//]]>
</script>


<header class="navbar navbar-gitlab navbar-expand-sm js-navbar" data-qa-selector="navbar">
<a class="sr-only gl-accessibility" href="#content-body" tabindex="1">Skip to content</a>
<div class="container-fluid">
<div class="header-content">
<div class="title-container">
<h1 class="title">
<a title="Dashboard" id="logo" href="/"><svg width="24" height="24" class="tanuki-logo" viewBox="0 0 36 36">
  <path class="tanuki-shape tanuki-left-ear" fill="#e24329" d="M2 14l9.38 9v-9l-4-12.28c-.205-.632-1.176-.632-1.38 0z"/>
  <path class="tanuki-shape tanuki-right-ear" fill="#e24329" d="M34 14l-9.38 9v-9l4-12.28c.205-.632 1.176-.632 1.38 0z"/>
  <path class="tanuki-shape tanuki-nose" fill="#e24329" d="M18,34.38 3,14 33,14 Z"/>
  <path class="tanuki-shape tanuki-left-eye" fill="#fc6d26" d="M18,34.38 11.38,14 2,14 6,25Z"/>
  <path class="tanuki-shape tanuki-right-eye" fill="#fc6d26" d="M18,34.38 24.62,14 34,14 30,25Z"/>
  <path class="tanuki-shape tanuki-left-cheek" fill="#fca326" d="M2 14L.1 20.16c-.18.565 0 1.2.5 1.56l17.42 12.66z"/>
  <path class="tanuki-shape tanuki-right-cheek" fill="#fca326" d="M34 14l1.9 6.16c.18.565 0 1.2-.5 1.56L18 34.38z"/>
</svg>

<span class="logo-text d-none d-lg-block prepend-left-8">
<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 617 169"><path d="M315.26 2.97h-21.8l.1 162.5h88.3v-20.1h-66.5l-.1-142.4M465.89 136.95c-5.5 5.7-14.6 11.4-27 11.4-16.6 0-23.3-8.2-23.3-18.9 0-16.1 11.2-23.8 35-23.8 4.5 0 11.7.5 15.4 1.2v30.1h-.1m-22.6-98.5c-17.6 0-33.8 6.2-46.4 16.7l7.7 13.4c8.9-5.2 19.8-10.4 35.5-10.4 17.9 0 25.8 9.2 25.8 24.6v7.9c-3.5-.7-10.7-1.2-15.1-1.2-38.2 0-57.6 13.4-57.6 41.4 0 25.1 15.4 37.7 38.7 37.7 15.7 0 30.8-7.2 36-18.9l4 15.9h15.4v-83.2c-.1-26.3-11.5-43.9-44-43.9M557.63 149.1c-8.2 0-15.4-1-20.8-3.5V70.5c7.4-6.2 16.6-10.7 28.3-10.7 21.1 0 29.2 14.9 29.2 39 0 34.2-13.1 50.3-36.7 50.3m9.2-110.6c-19.5 0-30 13.3-30 13.3v-21l-.1-27.8h-21.3l.1 158.5c10.7 4.5 25.3 6.9 41.2 6.9 40.7 0 60.3-26 60.3-70.9-.1-35.5-18.2-59-50.2-59M77.9 20.6c19.3 0 31.8 6.4 39.9 12.9l9.4-16.3C114.5 6 97.3 0 78.9 0 32.5 0 0 28.3 0 85.4c0 59.8 35.1 83.1 75.2 83.1 20.1 0 37.2-4.7 48.4-9.4l-.5-63.9V75.1H63.6v20.1h38l.5 48.5c-5 2.5-13.6 4.5-25.3 4.5-32.2 0-53.8-20.3-53.8-63-.1-43.5 22.2-64.6 54.9-64.6M231.43 2.95h-21.3l.1 27.3v94.3c0 26.3 11.4 43.9 43.9 43.9 4.5 0 8.9-.4 13.1-1.2v-19.1c-3.1.5-6.4.7-9.9.7-17.9 0-25.8-9.2-25.8-24.6v-65h35.7v-17.8h-35.7l-.1-38.5M155.96 165.47h21.3v-124h-21.3v124M155.96 24.37h21.3V3.07h-21.3v21.3"/></svg>

</span>
</a><a class="label-link canary-badge bg-transparent" target="_blank" href="https://next.gitlab.com"><span class="color-label has-tooltip badge badge-pill green-badge">
Next
</span>
</a></h1>
<ul class="list-unstyled navbar-sub-nav">
<li class="home"><a title="Projects" class="dashboard-shortcuts-projects" href="/explore">Projects
</a></li><li class=""><a title="Groups" class="dashboard-shortcuts-groups" href="/explore/groups">Groups
</a></li><li class=""><a title="Snippets" class="dashboard-shortcuts-snippets" href="/explore/snippets">Snippets
</a></li><li>
<a title="About GitLab CE" href="/help">Help</a>
</li>
</ul>

</div>
<div class="navbar-collapse collapse">
<ul class="nav navbar-nav">
<li class="nav-item d-none d-lg-block m-auto">
<div class="search search-form" data-track-event="activate_form_input" data-track-label="navbar_search" data-track-value="">
<form class="form-inline" action="/search" accept-charset="UTF-8" method="get"><input name="utf8" type="hidden" value="&#x2713;" /><div class="search-input-container">
<div class="search-input-wrap">
<div class="dropdown" data-url="/search/autocomplete">
<input type="search" name="search" id="search" placeholder="Search or jump to…" class="search-input dropdown-menu-toggle no-outline js-search-dashboard-options" spellcheck="false" tabindex="1" autocomplete="off" data-issues-path="/dashboard/issues" data-mr-path="/dashboard/merge_requests" data-qa-selector="search_term_field" aria-label="Search or jump to…" />
<button class="hidden js-dropdown-search-toggle" data-toggle="dropdown" type="button"></button>
<div class="dropdown-menu dropdown-select js-dashboard-search-options">
<div class="dropdown-content"><ul>
<li class="dropdown-menu-empty-item">
<a>
Loading...
</a>
</li>
</ul>
</div><div class="dropdown-loading"><i aria-hidden="true" data-hidden="true" class="fa fa-spinner fa-spin"></i></div>
</div>
<svg class="s16 search-icon"><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#search"></use></svg>
<svg class="s16 clear-icon js-clear-input"><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#close"></use></svg>
</div>
</div>
</div>
<input type="hidden" name="group_id" id="group_id" class="js-search-group-options" />
<input type="hidden" name="project_id" id="search_project_id" value="554859" class="js-search-project-options" data-project-path="gitlab-workhorse" data-name="gitlab-workhorse" data-issues-path="/gitlab-org/gitlab-workhorse/-/issues" data-mr-path="/gitlab-org/gitlab-workhorse/-/merge_requests" data-issues-disabled="false" />
<input type="hidden" name="search_code" id="search_code" value="true" />
<input type="hidden" name="repository_ref" id="repository_ref" value="master" />
<input type="hidden" name="nav_source" id="nav_source" value="navbar" />
<div class="search-autocomplete-opts hide" data-autocomplete-path="/search/autocomplete" data-autocomplete-project-id="554859" data-autocomplete-project-ref="master"></div>
</form></div>

</li>
<li class="nav-item d-inline-block d-lg-none">
<a title="Search" aria-label="Search" data-toggle="tooltip" data-placement="bottom" data-container="body" href="/search?project_id=554859"><svg class="s16"><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#search"></use></svg>
</a></li>
<li class="nav-item header-help dropdown d-none d-md-block">
<a class="header-help-dropdown-toggle" data-toggle="dropdown" href="/help"><svg class="s16"><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#question"></use></svg>
<svg class="caret-down"><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#angle-down"></use></svg>
</a><div class="dropdown-menu dropdown-menu-right">
<ul>
<li>
<a href="/help">Help</a>
</li>
<li>
<a href="https://about.gitlab.com/getting-help/">Support</a>
</li>
<li>
<button class="js-shortcuts-modal-trigger" type="button">
Keyboard shortcuts
<span aria-hidden class="text-secondary float-right">?</span>
</button>
</li>

<li class="divider"></li>
<li>
<a href="https://about.gitlab.com/submit-feedback">Submit feedback</a>
</li>
<li>
<a target="_blank" class="text-nowrap" href="https://about.gitlab.com/contributing">Contribute to GitLab
</a>

</li>

</ul>

</div>
</li>
<li class="nav-item">
<div>
<a class="btn btn-sign-in" href="/users/sign_in?redirect_to_referer=yes">Sign in / Register</a>
</div>
</li>
</ul>
</div>
<button class="navbar-toggler d-block d-sm-none" type="button">
<span class="sr-only">Toggle navigation</span>
<svg class="s12 more-icon js-navbar-toggle-right"><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#ellipsis_h"></use></svg>
<svg class="s12 close-icon js-navbar-toggle-left"><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#close"></use></svg>
</button>
</div>
</div>
</header>

<div class="layout-page page-with-contextual-sidebar">
<div class="nav-sidebar">
<div class="nav-sidebar-inner-scroll">
<div class="context-header">
<a title="gitlab-workhorse" href="/gitlab-org/gitlab-workhorse"><div class="avatar-container rect-avatar s40 project-avatar">
<img alt="gitlab-workhorse" class="avatar s40 avatar-tile lazy" width="40" height="40" data-src="https://assets.gitlab-static.net/uploads/-/system/project/avatar/554859/workhorse_logo.png" src="data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw==" />
</div>
<div class="sidebar-context-title">
gitlab-workhorse
</div>
</a></div>
<ul class="sidebar-top-level-items qa-project-sidebar">
<li class="home"><a class="shortcuts-project rspec-project-link" data-qa-selector="project_link" href="/gitlab-org/gitlab-workhorse"><div class="nav-icon-container">
<svg><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#home"></use></svg>
</div>
<span class="nav-item-name">
Project overview
</span>
</a><ul class="sidebar-sub-level-items">
<li class="fly-out-top-item"><a href="/gitlab-org/gitlab-workhorse"><strong class="fly-out-top-item-name">
Project overview
</strong>
</a></li><li class="divider fly-out-top-item"></li>
<li class=""><a title="Project details" class="shortcuts-project" href="/gitlab-org/gitlab-workhorse"><span>Details</span>
</a></li><li class=""><a title="Activity" class="shortcuts-project-activity" data-qa-selector="activity_link" href="/gitlab-org/gitlab-workhorse/activity"><span>Activity</span>
</a></li><li class=""><a title="Releases" class="shortcuts-project-releases" href="/gitlab-org/gitlab-workhorse/-/releases"><span>Releases</span>
</a></li></ul>
</li><li class="active"><a class="shortcuts-tree qa-project-menu-repo" href="/gitlab-org/gitlab-workhorse/-/tree/master"><div class="nav-icon-container">
<svg><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#doc-text"></use></svg>
</div>
<span class="nav-item-name" id="js-onboarding-repo-link">
Repository
</span>
</a><ul class="sidebar-sub-level-items">
<li class="fly-out-top-item active"><a href="/gitlab-org/gitlab-workhorse/-/tree/master"><strong class="fly-out-top-item-name">
Repository
</strong>
</a></li><li class="divider fly-out-top-item"></li>
<li class="active"><a href="/gitlab-org/gitlab-workhorse/-/tree/master">Files
</a></li><li class=""><a id="js-onboarding-commits-link" href="/gitlab-org/gitlab-workhorse/-/commits/master">Commits
</a></li><li class=""><a class="qa-branches-link" id="js-onboarding-branches-link" href="/gitlab-org/gitlab-workhorse/-/branches">Branches
</a></li><li class=""><a href="/gitlab-org/gitlab-workhorse/-/tags">Tags
</a></li><li class=""><a href="/gitlab-org/gitlab-workhorse/-/graphs/master">Contributors
</a></li><li class=""><a href="/gitlab-org/gitlab-workhorse/-/network/master">Graph
</a></li><li class=""><a href="/gitlab-org/gitlab-workhorse/-/compare?from=master&amp;to=master">Compare
</a></li><li class=""><a data-qa-selector="path_locks_link" href="/gitlab-org/gitlab-workhorse/path_locks">Locked Files
</a></li>
</ul>
</li><li class=""><a class="shortcuts-issues qa-issues-item" href="/gitlab-org/gitlab-workhorse/-/issues"><div class="nav-icon-container">
<svg><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#issues"></use></svg>
</div>
<span class="nav-item-name" id="js-onboarding-issues-link">
Issues
</span>
<span class="badge badge-pill count issue_counter">
70
</span>
</a><ul class="sidebar-sub-level-items">
<li class="fly-out-top-item"><a href="/gitlab-org/gitlab-workhorse/-/issues"><strong class="fly-out-top-item-name">
Issues
</strong>
<span class="badge badge-pill count issue_counter fly-out-badge">
70
</span>
</a></li><li class="divider fly-out-top-item"></li>
<li class=""><a title="Issues" href="/gitlab-org/gitlab-workhorse/-/issues"><span>
List
</span>
</a></li><li class=""><a title="Boards" data-qa-selector="issue_boards_link" href="/gitlab-org/gitlab-workhorse/-/boards"><span>
Boards
</span>
</a></li><li class=""><a title="Labels" class="qa-labels-link" href="/gitlab-org/gitlab-workhorse/-/labels"><span>
Labels
</span>
</a></li><li class=""><a title="Service Desk" href="/gitlab-org/gitlab-workhorse/-/issues/service_desk">Service Desk
</a></li>
<li class=""><a title="Milestones" class="qa-milestones-link" href="/gitlab-org/gitlab-workhorse/-/milestones"><span>
Milestones
</span>
</a></li></ul>
</li><li class=""><a class="shortcuts-merge_requests" data-qa-selector="merge_requests_link" href="/gitlab-org/gitlab-workhorse/-/merge_requests"><div class="nav-icon-container">
<svg><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#git-merge"></use></svg>
</div>
<span class="nav-item-name" id="js-onboarding-mr-link">
Merge Requests
</span>
<span class="badge badge-pill count merge_counter js-merge-counter">
13
</span>
</a><ul class="sidebar-sub-level-items is-fly-out-only">
<li class="fly-out-top-item"><a href="/gitlab-org/gitlab-workhorse/-/merge_requests"><strong class="fly-out-top-item-name">
Merge Requests
</strong>
<span class="badge badge-pill count merge_counter js-merge-counter fly-out-badge">
13
</span>
</a></li></ul>
</li>
<li class=""><a class="shortcuts-pipelines qa-link-pipelines rspec-link-pipelines" data-qa-selector="ci_cd_link" href="/gitlab-org/gitlab-workhorse/pipelines"><div class="nav-icon-container">
<svg><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#rocket"></use></svg>
</div>
<span class="nav-item-name" id="js-onboarding-pipelines-link">
CI / CD
</span>
</a><ul class="sidebar-sub-level-items">
<li class="fly-out-top-item"><a href="/gitlab-org/gitlab-workhorse/pipelines"><strong class="fly-out-top-item-name">
CI / CD
</strong>
</a></li><li class="divider fly-out-top-item"></li>
<li class=""><a title="Pipelines" class="shortcuts-pipelines" href="/gitlab-org/gitlab-workhorse/pipelines"><span>
Pipelines
</span>
</a></li><li class=""><a title="Jobs" class="shortcuts-builds" href="/gitlab-org/gitlab-workhorse/-/jobs"><span>
Jobs
</span>
</a></li><li class=""><a title="Schedules" class="shortcuts-builds" href="/gitlab-org/gitlab-workhorse/pipeline_schedules"><span>
Schedules
</span>
</a></li></ul>
</li><li class=""><a data-qa-selector="dependency_list_link" href="/gitlab-org/gitlab-workhorse/-/dependencies"><div class="nav-icon-container">
<svg><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#shield"></use></svg>
</div>
<span class="nav-item-name">
Security &amp; Compliance
</span>
</a><ul class="sidebar-sub-level-items">
<li class="fly-out-top-item"><a href="/gitlab-org/gitlab-workhorse/-/dependencies"><strong class="fly-out-top-item-name">
Security &amp; Compliance
</strong>
</a></li><li class="divider fly-out-top-item"></li>
<li class=""><a title="Dependency List" data-qa-selector="dependency_list_link" href="/gitlab-org/gitlab-workhorse/-/dependencies"><span>Dependency List</span>
</a></li><li class=""><a title="License Compliance" data-qa-selector="licenses_list_link" href="/gitlab-org/gitlab-workhorse/-/licenses"><span>License Compliance</span>
</a></li></ul>
</li>

<li class=""><a href="/gitlab-org/gitlab-workhorse/pipelines/charts"><div class="nav-icon-container">
<svg><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#chart"></use></svg>
</div>
<span class="nav-item-name" data-qa-selector="analytics_link">
Analytics
</span>
</a><ul class="sidebar-sub-level-items" data-qa-selector="analytics_sidebar_submenu">
<li class="fly-out-top-item"><a href="/gitlab-org/gitlab-workhorse/pipelines/charts"><strong class="fly-out-top-item-name">
Analytics
</strong>
</a></li><li class="divider fly-out-top-item"></li>
<li class=""><a title="CI / CD" href="/gitlab-org/gitlab-workhorse/pipelines/charts"><span>CI / CD</span>
</a></li><li class=""><a title="Code Review" href="/gitlab-org/gitlab-workhorse/-/analytics/code_reviews"><span>Code Review</span>
</a></li><li class=""><a class="shortcuts-project-insights" data-qa-selector="project_insights_link" title="Insights" href="/gitlab-org/gitlab-workhorse/insights/"><span>Insights</span>
</a></li><li class=""><a title="Issues" href="/gitlab-org/gitlab-workhorse/-/analytics/issues_analytics"><span>Issues</span>
</a></li><li class=""><a class="shortcuts-repository-charts" title="Repository" href="/gitlab-org/gitlab-workhorse/-/graphs/master/charts"><span>Repository</span>
</a></li><li class=""><a class="shortcuts-project-cycle-analytics" title="Value Stream" href="/gitlab-org/gitlab-workhorse/-/value_stream_analytics"><span>Value Stream</span>
</a></li></ul>
</li>
<li class=""><a title="Members" class="shortcuts-tree" href="/gitlab-org/gitlab-workhorse/-/settings/members"><div class="nav-icon-container">
<svg><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#users"></use></svg>
</div>
<span class="nav-item-name">
Members
</span>
</a><ul class="sidebar-sub-level-items is-fly-out-only">
<li class="fly-out-top-item"><a href="/gitlab-org/gitlab-workhorse/-/project_members"><strong class="fly-out-top-item-name">
Members
</strong>
</a></li></ul>
</li><a class="toggle-sidebar-button js-toggle-sidebar qa-toggle-sidebar rspec-toggle-sidebar" role="button" title="Toggle sidebar" type="button">
<svg class="icon-angle-double-left"><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#angle-double-left"></use></svg>
<svg class="icon-angle-double-right"><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#angle-double-right"></use></svg>
<span class="collapse-text">Collapse sidebar</span>
</a>
<button name="button" type="button" class="close-nav-button"><svg class="s16"><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#close"></use></svg>
<span class="collapse-text">Close sidebar</span>
</button>
<li class="hidden">
<a title="Activity" class="shortcuts-project-activity" href="/gitlab-org/gitlab-workhorse/activity"><span>
Activity
</span>
</a></li>
<li class="hidden">
<a title="Network" class="shortcuts-network" href="/gitlab-org/gitlab-workhorse/-/network/master">Graph
</a></li>
<li class="hidden">
<a class="shortcuts-new-issue" href="/gitlab-org/gitlab-workhorse/-/issues/new">Create a new issue
</a></li>
<li class="hidden">
<a title="Jobs" class="shortcuts-builds" href="/gitlab-org/gitlab-workhorse/-/jobs">Jobs
</a></li>
<li class="hidden">
<a title="Commits" class="shortcuts-commits" href="/gitlab-org/gitlab-workhorse/-/commits/master">Commits
</a></li>
<li class="hidden">
<a title="Issue Boards" class="shortcuts-issue-boards" href="/gitlab-org/gitlab-workhorse/-/boards">Issue Boards</a>
</li>
</ul>
</div>
</div>

<div class="content-wrapper">
<div class="mobile-overlay"></div>
<div class="alert-wrapper">









<nav class="breadcrumbs container-fluid container-limited limit-container-width" role="navigation">
<div class="breadcrumbs-container">
<button name="button" type="button" class="toggle-mobile-nav"><span class="sr-only">Open sidebar</span>
<i aria-hidden="true" data-hidden="true" class="fa fa-bars"></i>
</button><div class="breadcrumbs-links js-title-container" data-qa-selector="breadcrumb_links_content">
<ul class="list-unstyled breadcrumbs-list js-breadcrumbs-list">
<li><a class="group-path breadcrumb-item-text js-breadcrumb-item-text " href="/gitlab-org"><img class="avatar-tile lazy" width="15" height="15" data-src="https://assets.gitlab-static.net/uploads/-/system/group/avatar/9970/logo-extra-whitespace.png" src="data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw==" />GitLab.org</a><svg class="s8 breadcrumbs-list-angle"><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#angle-right"></use></svg></li> <li><a href="/gitlab-org/gitlab-workhorse"><img alt="gitlab-workhorse" class="avatar-tile lazy" width="15" height="15" data-src="https://assets.gitlab-static.net/uploads/-/system/project/avatar/554859/workhorse_logo.png" src="data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw==" /><span class="breadcrumb-item-text js-breadcrumb-item-text">gitlab-workhorse</span></a><svg class="s8 breadcrumbs-list-angle"><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#angle-right"></use></svg></li>

<li>
<h2 class="breadcrumbs-sub-title"><a href="/gitlab-org/gitlab-workhorse/-/tree/master">Repository</a></h2>
</li>
</ul>
</div>

</div>
</nav>

<div class="d-flex"></div>
</div>
<div class="container-fluid container-limited limit-container-width">
<div class="content" id="content-body">
<div class="flash-container flash-container-page sticky">
<div class="flash-notice mb-2">
<svg class="s16 align-middle mr-1"><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#information-o"></use></svg>
<span>&quot;doc/terminal.md&quot; did not exist on &quot;master&quot;</span>
<div class="close-icon-wrapper js-close-icon">
<svg class="s16 close-icon"><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#close"></use></svg>
</div>
</div>
</div>


<div class="tree-holder clearfix" id="tree-holder">
<div class="nav-block">
<div class="tree-ref-container">
<div class="tree-ref-holder">
<form class="project-refs-form" action="/gitlab-org/gitlab-workhorse/-/refs/switch" accept-charset="UTF-8" method="get"><input name="utf8" type="hidden" value="&#x2713;" /><input type="hidden" name="destination" id="destination" value="tree" />
<input type="hidden" name="path" id="path" value="" />
<div class="dropdown">
<button class="dropdown-menu-toggle js-project-refs-dropdown qa-branches-select" type="button" data-toggle="dropdown" data-selected="master" data-ref="master" data-refs-url="/gitlab-org/gitlab-workhorse/refs?sort=updated_desc" data-field-name="ref" data-submit-form-on-click="true" data-visit="true"><span class="dropdown-toggle-text ">master</span><i aria-hidden="true" data-hidden="true" class="fa fa-chevron-down"></i></button>
<div class="dropdown-menu dropdown-menu-paging dropdown-menu-selectable git-revision-dropdown qa-branches-dropdown">
<div class="dropdown-page-one">
<div class="dropdown-title"><span>Switch branch/tag</span><button class="dropdown-title-button dropdown-menu-close" aria-label="Close" type="button"><i aria-hidden="true" data-hidden="true" class="fa fa-times dropdown-menu-close-icon"></i></button></div>
<div class="dropdown-input"><input type="search" id="" class="dropdown-input-field qa-dropdown-input-field" placeholder="Search branches and tags" autocomplete="off" /><i aria-hidden="true" data-hidden="true" class="fa fa-search dropdown-input-search"></i><i aria-hidden="true" data-hidden="true" role="button" class="fa fa-times dropdown-input-clear js-dropdown-input-clear"></i></div>
<div class="dropdown-content"></div>
<div class="dropdown-loading"><i aria-hidden="true" data-hidden="true" class="fa fa-spinner fa-spin"></i></div>
</div>
</div>
</div>
</form>
</div>
<div data-can-collaborate="false" data-can-edit-tree="false" data-new-blob-path="/gitlab-org/gitlab-workhorse/-/new/master" data-new-branch-path="/gitlab-org/gitlab-workhorse/-/branches/new" data-new-dir-path="/gitlab-org/gitlab-workhorse/-/create_dir/master" data-new-tag-path="/gitlab-org/gitlab-workhorse/-/tags/new" data-upload-path="/gitlab-org/gitlab-workhorse/-/create/master" id="js-repo-breadcrumb"></div>
</div>
<div class="tree-controls">
<div class="d-block d-sm-flex flex-wrap align-items-start gl-children-ml-sm-3">
<div class="d-inline-block" data-history-link="/gitlab-org/gitlab-workhorse/-/commits/master" id="js-tree-history-link"></div>
<a class="btn shortcuts-find-file" rel="nofollow" href="/gitlab-org/gitlab-workhorse/-/find_file/master"><i aria-hidden="true" data-hidden="true" class="fa fa-search"></i>
<span>Find file</span>
</a><div class="project-action-button dropdown inline">
<button aria-label="Download" class="btn has-tooltip" data-qa-selector="download_source_code_button" data-display="static" data-toggle="dropdown" title="Download">
<svg><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#download"></use></svg>
<span class="sr-only">Select Archive Format</span>
<svg><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#chevron-down"></use></svg>
</button>
<div class="dropdown-menu dropdown-menu-right" role="menu">
<section>
<h5 class="m-0 dropdown-bold-header">Download source code</h5>
<div class="dropdown-menu-content">
<div class="btn-group ml-0 w-100">
<a rel="nofollow" download="" class="btn btn-xs btn-primary" href="/gitlab-org/gitlab-workhorse/-/archive/master/gitlab-workhorse-master.zip">zip</a>
<a rel="nofollow" download="" class="btn btn-xs " href="/gitlab-org/gitlab-workhorse/-/archive/master/gitlab-workhorse-master.tar.gz">tar.gz</a>
<a rel="nofollow" download="" class="btn btn-xs " href="/gitlab-org/gitlab-workhorse/-/archive/master/gitlab-workhorse-master.tar.bz2">tar.bz2</a>
<a rel="nofollow" download="" class="btn btn-xs " href="/gitlab-org/gitlab-workhorse/-/archive/master/gitlab-workhorse-master.tar">tar</a>
</div>

</div>
</section>
<div data-links="[{&quot;text&quot;:&quot;zip&quot;,&quot;path&quot;:&quot;/gitlab-org/gitlab-workhorse/-/archive/master/gitlab-workhorse-master.zip&quot;},{&quot;text&quot;:&quot;tar.gz&quot;,&quot;path&quot;:&quot;/gitlab-org/gitlab-workhorse/-/archive/master/gitlab-workhorse-master.tar.gz&quot;},{&quot;text&quot;:&quot;tar.bz2&quot;,&quot;path&quot;:&quot;/gitlab-org/gitlab-workhorse/-/archive/master/gitlab-workhorse-master.tar.bz2&quot;},{&quot;text&quot;:&quot;tar&quot;,&quot;path&quot;:&quot;/gitlab-org/gitlab-workhorse/-/archive/master/gitlab-workhorse-master.tar&quot;}]" id="js-directory-downloads"></div>
</div>
</div><div class="project-clone-holder d-none d-md-inline-block">
<div class="git-clone-holder js-git-clone-holder">
<a class="btn btn-primary clone-dropdown-btn qa-clone-dropdown" data-toggle="dropdown" href="#" id="clone-dropdown">
<span class="append-right-4 js-clone-dropdown-label">
Clone
</span>
<svg class="icon"><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#chevron-down"></use></svg>
</a>
<ul class="clone-options-dropdown dropdown-menu dropdown-menu-large dropdown-menu-right dropdown-menu-selectable p-3 qa-clone-options">
<li>
<label class="label-bold">
Clone with SSH
</label>
<div class="input-group">
<input type="text" name="ssh_project_clone" id="ssh_project_clone" value="git@gitlab.com:gitlab-org/gitlab-workhorse.git" class="js-select-on-focus form-control qa-ssh-clone-url" readonly="readonly" aria-label="Project clone URL" />
<div class="input-group-append">
<button class="btn input-group-text btn-default btn-clipboard" data-toggle="tooltip" data-placement="bottom" data-container="body" data-title="Copy URL" data-class="input-group-text btn-default btn-clipboard" data-clipboard-target="#ssh_project_clone" type="button" title="Copy URL" aria-label="Copy URL"><svg><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#copy-to-clipboard"></use></svg></button>

</div>
</div>
</li>
<li class="pt-2">
<label class="label-bold">
Clone with HTTPS
</label>
<div class="input-group">
<input type="text" name="http_project_clone" id="http_project_clone" value="https://gitlab.com/gitlab-org/gitlab-workhorse.git" class="js-select-on-focus form-control qa-http-clone-url" readonly="readonly" aria-label="Project clone URL" />
<div class="input-group-append">
<button class="btn input-group-text btn-default btn-clipboard" data-toggle="tooltip" data-placement="bottom" data-container="body" data-title="Copy URL" data-class="input-group-text btn-default btn-clipboard" data-clipboard-target="#http_project_clone" type="button" title="Copy URL" aria-label="Copy URL"><svg><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#copy-to-clipboard"></use></svg></button>

</div>
</div>
</li>

</ul>
</div>

</div></div><div class="project-clone-holder d-block d-md-none mt-sm-2 mt-md-0 ml-sm-2">
<div class="btn-group mobile-git-clone js-mobile-git-clone btn-block">
<button class="btn btn-primary flex-fill bold justify-content-center input-group-text clone-dropdown-btn js-clone-dropdown-label" data-toggle="tooltip" data-placement="bottom" data-container="body" data-button-text="Copy HTTPS clone URL" data-hide-button-icon="true" data-class="btn-primary flex-fill bold justify-content-center input-group-text clone-dropdown-btn js-clone-dropdown-label" data-clipboard-text="https://gitlab.com/gitlab-org/gitlab-workhorse.git" type="button" title="Copy" aria-label="Copy">Copy HTTPS clone URL</button>
<button class="btn btn-primary dropdown-toggle js-dropdown-toggle flex-grow-0 d-flex-center w-auto ml-0" data-toggle="dropdown" type="button">
<svg class="dropdown-btn-icon icon"><use xlink:href="https://gitlab.com/assets/icons-08baceaa8b3d86902032f77e02487f6fb85bad88ef0e20d42440fe83757c50ab.svg#chevron-down"></use></svg>
</button>
<ul class="dropdown-menu dropdown-menu-selectable dropdown-menu-right clone-options-dropdown" data-dropdown>
<li>
<a class="copy ssh clone url-selector is-active" href="git@gitlab.com:gitlab-org/gitlab-workhorse.git" data-clone-type="ssh"><strong class="dropdown-menu-inner-title">Copy SSH clone URL</strong><span class="dropdown-menu-inner-content"><span class="__cf_email__" data-cfemail="03646a7743646a776f62612d606c6e">[email&#160;protected]</span>:gitlab-org/gitlab-workhorse.git</span></a>
</li>
<li>
<a class="copy https clone url-selector " href="https://gitlab.com/gitlab-org/gitlab-workhorse.git" data-clone-type="http"><strong class="dropdown-menu-inner-title">Copy HTTPS clone URL</strong><span class="dropdown-menu-inner-content">https://gitlab.com/gitlab-org/gitlab-workhorse.git</span></a>
</li>

</ul>
</div>

</div></div>

</div>
<div id="js-last-commit"></div>
<div data-full-name="GitLab.org / gitlab-workhorse" data-path-locks-available="true" data-path-locks-toggle="/gitlab-org/gitlab-workhorse/path_locks/toggle" data-project-path="gitlab-org/gitlab-workhorse" data-project-short-path="gitlab-workhorse" data-ref="master" id="js-tree-list"></div>
</div>


</div>
</div>
</div>
</div>




<script data-cfasync="false" src="/cdn-cgi/scripts/5c5dd728/cloudflare-static/email-decode.min.js"></script></body>
</html>

